Public Class MainForm
    Public strDirectoryPath As String '   
    Public UBaROM As Integer = -1 '     
    Private Sub MainForm_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            FileOpen(9, "FirstValues.vp", OpenMode.Input)
            subLoadTuning(CInt(LineInput(9)))
            FileClose(9)
        Catch
            MsgBox("   FirstValues.vp,      ,     .        .", MsgBoxStyle.Exclamation, " ")
            FileClose(9)
        End Try
        strDirectoryPath = CurDir()
    End Sub

    Private Sub msLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles msLoad.Click
        Dim myOFD As New OpenFileDialog
        myOFD.Filter = " |*.*|NES (*.nes)|*.nes|GameBoy (*.gb, *.gbc)|*.gb; *.gbc|SNES (*.smc, *.fig)|*.smc; *.fig|Sega Genesis (*.smd, *.bin)|*.smd; *.bin|GBA (*.gba)|*.gba"
        If myOFD.ShowDialog = Windows.Forms.DialogResult.OK Then
            FileOpen(9, myOFD.FileName, OpenMode.Binary)
            If LOF(9) = 0 Then
                MsgBox("      .    ", MsgBoxStyle.Exclamation, " ")
                FileClose(9)
                Exit Sub
            End If
            myFileName = myOFD.FileName
            UBaROM = LOF(9) - 1
            ReDim aROM(UBaROM)
            FileGet(9, aROM)
            FileClose(9)

            numHexFrom.Maximum = UBaROM
            numDecFrom.Maximum = UBaROM
            numHexTo.Maximum = UBaROM
            numDecTo.Maximum = UBaROM
            btnPoganka.Enabled = True
            btnReconstruction.Enabled = True
            gb1.Enabled = True
            msSaveDiag.Enabled = True

            ReDim aDiag(2)
            aDiag(0) = 0
            aDiag(1) = 6
            aDiag(2) = UBaROM + 1
            lbReport.Text = " "
            panDiag1.Height = 49
            panDiag1.Refresh()
            panDiag2.Refresh()
        End If
    End Sub
    Private Sub msClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles msClose.Click
        Me.Close()
    End Sub
    Private Sub msSaveDiag_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles msSaveDiag.Click
        Dim mySFD As New SaveFileDialog
        Dim i As Integer
        mySFD.Filter = "   (*.vpDiag)|*.vpDiag| |*.*"
        mySFD.FileName = "Results.vpDiag"
        If mySFD.ShowDialog = Windows.Forms.DialogResult.OK Then
            FileOpen(9, mySFD.FileName, OpenMode.Output)
            subSaveTuning()
            For i = 0 To aDiag.GetUpperBound(0)
                PrintLine(9, aDiag(i).ToString)
            Next
            FileClose(9)
            lbReport.Text = "   " & vbCrLf & mySFD.FileName
        End If
    End Sub
    Private Sub msLoadDiagWith_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles msLoadDiagWith.Click
        subVariantsLoadDiagram(True)
    End Sub
    Private Sub msLoadDiagWithout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles msLoadDiagWithout.Click
        subVariantsLoadDiagram(False)
    End Sub
    Private Sub msSaveTuning_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles msSaveTuning.Click
        If MsgBox("  FirstValues.vp,     ,  .      ,        ." & vbCrLf & "?", MsgBoxStyle.OkCancel Or MsgBoxStyle.Information, "  ?") = MsgBoxResult.Ok Then
            FileOpen(9, strDirectoryPath & "\FirstValues.vp", OpenMode.Output)
            subSaveTuning()
            FileClose(9)
            lbReport.Text = " "
        End If
    End Sub
    Private Sub msHex_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles msHex.CheckedChanged
        If msHex.Checked Then
            numWorkBegin.Hexadecimal = True
            numWorkEnd.Hexadecimal = True
            numOnly.Hexadecimal = True
            numConst.Hexadecimal = True
            numPlus.Hexadecimal = True
            numMinus.Hexadecimal = True
            lbWorkBegin.Text = "h  "
            lbWorkEnd.Text = "h  ()"
            lbOnly.Text = "h"
            lbConst.Text = "h  (const)"
            lbPlus.Text = "h"
            lbMinus.Text = "h"
        Else
            numWorkBegin.Hexadecimal = False
            numWorkEnd.Hexadecimal = False
            numConst.Hexadecimal = False
            numPlus.Hexadecimal = False
            numMinus.Hexadecimal = False
            numOnly.Hexadecimal = False
            lbWorkBegin.Text = "d  "
            lbWorkEnd.Text = "d  ()"
            lbOnly.Text = "d"
            lbConst.Text = "d  (const)"
            lbPlus.Text = "d"
            lbMinus.Text = "d"
        End If
    End Sub
    Private Sub msHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles msHelp.Click
        Dim i As Integer = 10
        MsgBox(":" & vbTab & "Visual Poganka" & vbCrLf & _
               ":" & vbTab & vbTab & "1.101" & vbCrLf & _
               ":" & vbTab & vbTab & "2007" & vbCrLf & _
               ":" & vbTab & vbTab & "BHLady" & vbCrLf & _
               "E-mail:" & vbTab & vbTab & "bhlady@mail.ru" & vbCrLf & _
               "WWW-" & vbCrLf & _
               ":" & vbTab & "http://bhlady.narod.ru/programs/vp.htm" & vbCrLf & _
               vbTab & vbTab & "(  )", MsgBoxStyle.Information, " ")
    End Sub

    Private Sub subVariantsLoadDiagram(ByVal bTuning As Boolean)
        Dim myOFD As New OpenFileDialog
        Dim i As Integer
        myOFD.Filter = "   (*.vpDiag)|*.vpDiag| |*.*"
        myOFD.FileName = "Results.vpDiag"
        If myOFD.ShowDialog = Windows.Forms.DialogResult.OK Then
            Try
                FileOpen(9, myOFD.FileName, OpenMode.Input)
                i = CInt(LineInput(9))
                If btnPoganka.Enabled AndAlso i <> UBaROM Then
                    MsgBox(" ,         ,   .  ", MsgBoxStyle.Exclamation, " ")
                    FileClose(9)
                    Exit Sub
                End If

                If bTuning Then
                    subLoadTuning(i)
                Else
                    For i = 2 To 26
                        LineInput(9)
                    Next
                End If

                i = -1
                While Not EOF(9)
                    i += 1
                    ReDim Preserve aDiag(i)
                    aDiag(i) = CInt(LineInput(9))
                End While
                FileClose(9)
                panDiag1.Height = aDiag.GetUpperBound(0) * 16 + 17
                panDiag1.Refresh()
                panDiag2.Refresh()

                If bTuning Then
                    lbReport.Text = " " & vbCrLf & "(  " & vbCrLf & ")"
                Else
                    lbReport.Text = " " & vbCrLf & "(  " & vbCrLf & ")"
                End If
            Catch
                MsgBox("     .  ,      .       ", MsgBoxStyle.Exclamation, " ")
                FileClose(9)
            End Try
        End If
    End Sub
    Private Sub subSaveTuning()
        PrintLine(9, numDecFrom.Maximum.ToString)
        PrintLine(9, numDecFrom.Value.ToString)
        PrintLine(9, numDecTo.Value.ToString)
        PrintLine(9, numThrough.Value.ToString)
        PrintLine(9, numDecFrom.Increment.ToString)

        PrintLine(9, Left.ToString)
        PrintLine(9, Top.ToString)
        PrintLine(9, Height.ToString)

        PrintLine(9, numWorkBegin.Value.ToString)
        PrintLine(9, numWorkEnd.Value.ToString)
        PrintLine(9, numOnly.Value.ToString)
        PrintLine(9, numConst.Value.ToString)
        PrintLine(9, numPlus.Value.ToString)
        PrintLine(9, numMinus.Value.ToString)

        If rbHex.Checked Then
            PrintLine(9, "1")
        Else
            PrintLine(9, "2")
        End If
        If rbAll.Checked Then
            PrintLine(9, "1")
        ElseIf rbRange.Checked Then
            PrintLine(9, "2")
        Else
            PrintLine(9, "3")
        End If
        If rbConst.Checked Then
            PrintLine(9, "1")
        ElseIf rbPlus.Checked Then
            PrintLine(9, "2")
        Else
            PrintLine(9, "3")
        End If
        PrintLine(9, chbThrough.Checked.ToString)
        PrintLine(9, msHex.Checked.ToString)

        PrintLine(9, bCycle.ToString)
        PrintLine(9, bRAM.ToString)

        PrintLine(9, qfnum1.ToString)
        PrintLine(9, qfnum2.ToString)
        PrintLine(9, qfrb.ToString)
        PrintLine(9, qfReconstruction.ToString)
        PrintLine(9, qfHex.ToString)
    End Sub
    Private Sub subLoadTuning(ByVal i As Integer)
        numHexFrom.Maximum = i
        numDecFrom.Maximum = i
        numHexTo.Maximum = i
        numDecTo.Maximum = i
        numDecFrom.Value = CInt(LineInput(9))
        numDecTo.Value = CInt(LineInput(9))
        numThrough.Value = CInt(LineInput(9))
        numDecFrom.Increment = CInt(LineInput(9))
        numDecTo.Increment = numDecFrom.Increment
        numHexFrom.Increment = 16 ^ Math.Log10(numDecFrom.Increment)
        numHexTo.Increment = numHexFrom.Increment

        Left = CInt(LineInput(9))
        Top = CInt(LineInput(9))
        Height = CInt(LineInput(9))

        numWorkBegin.Value = CInt(LineInput(9))
        numWorkEnd.Value = CInt(LineInput(9))
        numOnly.Value = CInt(LineInput(9))
        numConst.Value = CInt(LineInput(9))
        numPlus.Value = CInt(LineInput(9))
        numMinus.Value = CInt(LineInput(9))

        Choose(CInt(LineInput(9)), rbHex, rbDec).checked = True
        Choose(CInt(LineInput(9)), rbAll, rbRange, rbOnly).checked = True
        Choose(CInt(LineInput(9)), rbConst, rbPlus, rbMinus).checked = True
        chbThrough.Checked = CBool(LineInput(9))
        msHex.Checked = CBool(LineInput(9))

        bCycle = CBool(LineInput(9))
        bRAM = CBool(LineInput(9))

        qfnum1 = CInt(LineInput(9))
        qfnum2 = CInt(LineInput(9))
        qfrb = CByte(LineInput(9))
        qfReconstruction = CBool(LineInput(9))
        qfHex = CBool(LineInput(9))
    End Sub

    Private Sub numDecFrom_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles numDecFrom.KeyUp
        numHexFrom.Value = numDecFrom.Value
    End Sub
    Private Sub numDecTo_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles numDecTo.KeyUp
        numHexTo.Value = numDecTo.Value
    End Sub
    Private Sub numHexFrom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numHexFrom.ValueChanged
        numDecFrom.Value = numHexFrom.Value
    End Sub
    Private Sub numDecFrom_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numDecFrom.ValueChanged
        numHexFrom.Value = numDecFrom.Value
    End Sub
    Private Sub numHexTo_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numHexTo.ValueChanged
        numDecTo.Value = numHexTo.Value
    End Sub
    Private Sub numDecTo_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numDecTo.ValueChanged
        numHexTo.Value = numDecTo.Value
    End Sub
    Private Sub EnterOnAddressFields(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles numHexFrom.KeyPress, numDecFrom.KeyPress, numHexTo.KeyPress, numDecTo.KeyPress, numThrough.KeyPress
        If e.KeyChar = Chr(13) Then btnPoganka_Click(sender, e)
    End Sub
    Private Sub numThrough_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles numThrough.ValueChanged
        If numThrough.Value Mod 10 = 3 Then
            If numThrough.Value = 13 Then
                lbThrough.Text = "-"
            Else
                lbThrough.Text = "-"
            End If
        Else
            lbThrough.Text = "-"
        End If
    End Sub

    Private Sub chbThrough_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chbThrough.CheckedChanged
        numThrough.Enabled = chbThrough.Checked
    End Sub
    Private Sub rbHex_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbHex.CheckedChanged
        If rbHex.Checked Then
            numHexFrom.Enabled = True
            numHexTo.Enabled = True
            numDecFrom.Enabled = False
            numDecTo.Enabled = False
            numHexFrom.Focus()
        Else
            numHexFrom.Enabled = False
            numHexTo.Enabled = False
            numDecFrom.Enabled = True
            numDecTo.Enabled = True
            numDecFrom.Focus()
        End If
    End Sub
    Private Sub ChangeGB2(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbAll.CheckedChanged, rbRange.CheckedChanged, rbOnly.CheckedChanged
        If rbAll.Checked Then
            numWorkBegin.Enabled = False
            numWorkEnd.Enabled = False
            numOnly.Enabled = False
        ElseIf rbRange.Checked Then
            numWorkBegin.Enabled = True
            numWorkEnd.Enabled = True
            numOnly.Enabled = False
            numWorkBegin.Focus()
        Else
            numWorkBegin.Enabled = False
            numWorkEnd.Enabled = False
            numOnly.Enabled = True
            numOnly.Focus()
        End If
    End Sub
    Private Sub ChangeGB3(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbConst.CheckedChanged, rbPlus.CheckedChanged, rbMinus.CheckedChanged
        If rbConst.Checked Then
            numConst.Enabled = True
            numPlus.Enabled = False
            numMinus.Enabled = False
            numConst.Focus()
        ElseIf rbPlus.Checked Then
            numConst.Enabled = False
            numPlus.Enabled = True
            numMinus.Enabled = False
            numPlus.Focus()
        Else
            numConst.Enabled = False
            numPlus.Enabled = False
            numMinus.Enabled = True
            numMinus.Focus()
        End If
    End Sub

    Private Sub btnPoganka_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPoganka.Click
        '--------------------------------       --------
        Dim vDecFrom As Integer = numDecFrom.Value
        Dim vDecTo As Integer = numDecTo.Value
        If vDecFrom > vDecTo Then
            MsgBox("    ", MsgBoxStyle.Exclamation, " ")
            Exit Sub
        End If

        Dim vThrough As Integer = 1
        If chbThrough.Checked Then
            vThrough = numThrough.Value
        End If

        Dim vWorkBegin As Byte
        Dim vWorkEnd As Byte
        If rbRange.Checked Then
            vWorkBegin = numWorkBegin.Value
            vWorkEnd = numWorkEnd.Value
        ElseIf rbAll.Checked Then
            vWorkBegin = 0
            vWorkEnd = 255
        Else
            vWorkBegin = numOnly.Value
            vWorkEnd = numOnly.Value
        End If
        If vWorkBegin >= vWorkEnd Then
            If vWorkBegin > vWorkEnd Then
                MsgBox("      .", MsgBoxStyle.Exclamation, " ")
                Exit Sub
            End If
            If rbPlus.Checked OrElse rbMinus.Checked Then
                MsgBox("  /        ,    .       .       ,      ", MsgBoxStyle.Exclamation, " ")
                Exit Sub
            End If
        End If

        '-----------------------------------      -------------------
        Dim aAdd(vDecTo - vDecFrom) As Byte
        Dim i As Integer
        If bRAM Then
            For i = vDecFrom To vDecTo
                aAdd(i - vDecFrom) = aROM(i)
            Next
        Else
            FileOpen(9, myFileName, OpenMode.Binary)
            FileGet(9, aAdd, vDecFrom + 1)
            FileClose(9)
        End If

        '--------------------------   (    ) --------------
        If rbConst.Checked Then
            For i = 0 To aAdd.GetUpperBound(0) Step vThrough
                If aAdd(i) >= vWorkBegin AndAlso aAdd(i) <= vWorkEnd Then aAdd(i) = numConst.Value
            Next

        ElseIf rbPlus.Checked Then
            Try
                If bCycle Then
                    Dim vPlus As Byte = numPlus.Value Mod (vWorkEnd - vWorkBegin + 1)
                    Dim vTran As Byte = vWorkEnd - vPlus + 1
                    Dim iii As Byte = vWorkEnd - vWorkBegin - vPlus + 1
                    For i = 0 To aAdd.GetUpperBound(0) Step vThrough
                        If aAdd(i) >= vWorkBegin AndAlso aAdd(i) <= vWorkEnd Then
                            If aAdd(i) < vTran Then
                                aAdd(i) += vPlus
                            Else
                                aAdd(i) -= iii
                            End If
                        End If
                    Next
                Else
                    Dim vPlus As Byte = numPlus.Value
                    Dim vTran As Byte = vWorkEnd - vPlus + 1
                    For i = 0 To aAdd.GetUpperBound(0) Step vThrough
                        If aAdd(i) >= vWorkBegin AndAlso aAdd(i) <= vWorkEnd Then
                            If aAdd(i) < vTran Then
                                aAdd(i) += vPlus
                            Else
                                aAdd(i) = vWorkEnd
                            End If
                        End If
                    Next
                End If
            Catch
                'If vWorkEnd - vPlus + 1>255 (.. vplus=0) Then   
                If CInt(vWorkEnd) - numPlus.Value + 1 < 0 Then
                    For i = 0 To aAdd.GetUpperBound(0) Step vThrough
                        If aAdd(i) >= vWorkBegin AndAlso aAdd(i) <= vWorkEnd Then aAdd(i) = vWorkEnd
                    Next
                End If
            End Try

        Else 'rbMinus.Checked
            Try
                If bCycle Then
                    Dim vMinus As Byte = numMinus.Value Mod (vWorkEnd - vWorkBegin + 1)
                    Dim vTran As Byte = vWorkBegin + vMinus - 1
                    Dim iii As Byte = vWorkEnd - vWorkBegin - vMinus + 1
                    For i = 0 To aAdd.GetUpperBound(0) Step vThrough
                        If aAdd(i) >= vWorkBegin AndAlso aAdd(i) <= vWorkEnd Then
                            If aAdd(i) > vTran Then
                                aAdd(i) -= vMinus
                            Else
                                aAdd(i) += iii
                            End If
                        End If
                    Next
                Else
                    Dim vMinus As Byte = numMinus.Value
                    Dim vTran As Byte = vWorkBegin + vMinus - 1
                    For i = 0 To aAdd.GetUpperBound(0) Step vThrough
                        If aAdd(i) >= vWorkBegin AndAlso aAdd(i) <= vWorkEnd Then
                            If aAdd(i) > vTran Then
                                aAdd(i) -= vMinus
                            Else
                                aAdd(i) = vWorkBegin
                            End If
                        End If
                    Next
                End If
            Catch
                'if vWorkBegin + vMinus - 1<0 (.. numMinus.Value=0) Then   
                If CInt(vWorkBegin) + numMinus.Value - 1 > 255 Then
                    For i = 0 To aAdd.GetUpperBound(0) Step vThrough
                        If aAdd(i) >= vWorkBegin AndAlso aAdd(i) <= vWorkEnd Then aAdd(i) = vWorkBegin
                    Next
                End If
            End Try
        End If

        '-----------------------------------------      ----------------
        FileOpen(9, myFileName, OpenMode.Binary)
        FilePut(9, aAdd, vDecFrom + 1)
        FileClose(9)

        '----------------------------------------    -------------------
        Dim fQF As New QuestionForm
        fQF.ShowDialog()
        fQF = Nothing

        '----------------------------------------   () -----------
        If qfReconstruction Then
            For i = vDecFrom To vDecTo
                aAdd(i - vDecFrom) = aROM(i)
            Next
            FileOpen(9, myFileName, OpenMode.Binary)
            FilePut(9, aAdd, vDecFrom + 1)
            FileClose(9)
        End If

        '------------------------------------   ------------------
        aAdd = Nothing
        panDiag1.Height = aDiag.GetUpperBound(0) * 16 + 17
        panDiag1.Refresh()
        panDiag2.Refresh()

        Dim str As String = " " & vbCrLf & _
                            " " & numHexFrom.Text & " h (" & vDecFrom.ToString & " d)" & vbCrLf & _
                            " " & numHexTo.Text & " h (" & vDecTo.ToString & " d)" & vbCrLf
        If chbThrough.Checked Then
            str &= "  " & vThrough.ToString
            If vThrough >= 9 AndAlso vThrough <= 21 Then
                str &= "- " & vbCrLf
            Else
                Select Case vThrough Mod 10
                    Case 2, 6, 7, 8
                        str &= "- " & vbCrLf
                    Case 3
                        str &= "- " & vbCrLf
                    Case Else
                        str &= "- " & vbCrLf
                End Select
            End If
        Else
            str &= " " & vbCrLf
        End If
        If qfReconstruction Then
            str &= "( )"
        Else
            str &= "(  )"
        End If

        '--------------------------------       () -----
        Select Case qfrb
            Case 1
                numDecFrom.Value = vDecTo + 1
                numDecTo.Value = vDecTo + qfnum1
            Case 2
                numDecTo.Value = vDecFrom - 1
                numDecFrom.Value = vDecFrom - qfnum2
            Case 3
                numDecFrom.Value = 0
                numDecTo.Value = 0
        End Select

        lbReport.Text = str
    End Sub
    Private Sub btnSecondary_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSecondary.Click
        Dim fSF As New SecondaryForm
        fSF.ShowDialog()
    End Sub
    Private Sub btnReconstruction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReconstruction.Click
        FileOpen(9, myFileName, OpenMode.Binary)
        FilePut(9, aROM)
        FileClose(9)
        lbReport.Text = " "
    End Sub

    Private Sub panDiag1_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles panDiag1.Paint
        Dim gDiag1 As Graphics = panDiag1.CreateGraphics()
        Dim str As String
        Dim myFont As New Font("courier", 10)
        gDiag1.DrawString("hex            dec", myFont, Brushes.Black, 6, 0)

        For i As Integer = 2 To aDiag.GetUpperBound(0) Step 2
            gDiag1.DrawRectangle(Pens.Black, 61, i * 16 - 16, 32, 32)
            gDiag1.FillRectangle(Choose(aDiag(i - 1), Brushes.DodgerBlue, Brushes.Lime, Brushes.Red, Brushes.Yellow, Brushes.Gray, Brushes.LightGray), 62, i * 16 - 15, 31, 31)
            str = Hex(aDiag(i - 2)).ToString
            gDiag1.DrawString(str, myFont, Brushes.Black, 56 - str.Length * 8, i * 16 - 18)
            gDiag1.DrawString((aDiag(i - 2)).ToString, myFont, Brushes.Black, 94, i * 16 - 18)
            str = Hex(aDiag(i) - 1).ToString
            gDiag1.DrawString(str, myFont, Brushes.Black, 56 - str.Length * 8, 3 + i * 16)
            gDiag1.DrawString((aDiag(i) - 1).ToString, myFont, Brushes.Black, 94, 3 + i * 16)
        Next
    End Sub
    Private Sub panDiag2_Paint(ByVal sender As System.Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles panDiag2.Paint
        Dim gDiag2 As Graphics = panDiag2.CreateGraphics()
        Dim heightDiag As Integer = ((Me.Height - 52) \ 20) * 20
        gDiag2.DrawRectangle(Pens.Black, 61, 16, 32, heightDiag)
        Dim myFont As New Font("courier", 10)
        gDiag2.DrawString("hex            dec", myFont, Brushes.Black, 6, 0)
        Dim UB As Integer = aDiag(aDiag.GetUpperBound(0))
        Dim hd As Integer = heightDiag - 1
        Dim sectionB, sectionL As Integer
        Dim i As Integer
        Dim str As String


        For i = 2 To aDiag.GetUpperBound(0) Step 2
            sectionB = Math.Floor(CSng(aDiag(i - 2)) / UB * hd + 17)
            sectionL = Math.Ceiling(CSng(aDiag(i) - aDiag(i - 2)) / UB * hd)
            gDiag2.FillRectangle(Choose(aDiag(i - 1), Brushes.DodgerBlue, Brushes.Lime, Brushes.Red, Brushes.Yellow, Brushes.Gray, Brushes.LightGray), 62, sectionB, 31, sectionL)
            str = Hex(aDiag(i - 2)).ToString
            gDiag2.DrawString(str, myFont, Brushes.Black, 56 - str.Length * 8, sectionB - 2)
            gDiag2.DrawString((aDiag(i - 2)).ToString, myFont, Brushes.Black, 94, sectionB - 2)
            str = Hex(aDiag(i) - 1).ToString
            gDiag2.DrawString(str, myFont, Brushes.Black, 56 - str.Length * 8, sectionB + sectionL - 14)
            gDiag2.DrawString((aDiag(i) - 1).ToString, myFont, Brushes.Black, 94, sectionB + sectionL - 14)
        Next

        hd = heightDiag / 10
        For i = 16 To 9 * hd + 16 Step hd
            gDiag2.DrawLine(Pens.Black, 62, i, 67, i)
            gDiag2.DrawLine(Pens.Black, 62, i + hd \ 2, 63, i + hd \ 2)
        Next
        gDiag2.DrawLine(Pens.Black, 68, 5 * hd + 16, 74, 5 * hd + 16)
    End Sub
    Private Sub panDiag2_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles panDiag2.SizeChanged
        panDiag2.Refresh()
    End Sub
End Class
